let rec eval_expr expr (sigma:state) =
  match expr with

    | Expr_Num(n) -> ((int_to_value n):value)
    | _ -> failwith "eval_expr"
;;

exception Stopped of state;;

let rec step (p, (sigma:state)) = match p with

  | Skip -> (Stop, sigma)

  | Assign(x,e) ->
      let sigma' = (update sigma x (eval_expr e sigma))
      in (Stop, sigma')
  | _ -> failwith "step"	   
;;

let rec run (p, sigma) =
  let (p', sigma') = step (p, sigma) in 
    begin
      run (p', sigma')
    end
;;

let result (p, sigma) = 
  try run (p, sigma) with Stopped(sigma') -> sigma'
;;

let go_step file =
  let prog = parse (file_to_string file) in
    begin
      print_string "\n\n\nStructured Operational Semantics\n";
      print_line ();
      print prog;
      print_line ();
      let sigma = result (prog, sigma0) in 
	begin
	  print_string "Program stopped!\n";
	  print_line ();
        end
    end
;;
